#include <bits/stdc++.h>
using namespace std;

#define REP(i,n) for(int i = 0; i < (n); ++i)
#define FOR(i,a,b) for(int i = (a); i <= (b); ++i)
#define FORD(i,a,b) for(int i = (a); i >= (b); --i)

#define pii pair<double,double>

#define maxN 105


int N;
int x1, x2, y1, y2;
vector<int> poly[maxN];
vector<pair<pii, pii>> segs;

int cross(pii A, pii B) {
  return A.X * B.Y - A.Y * B.X;
}

bool intersect(pii a, pii b, pii c, pii d) {
  return (cross({b.X - a.X, b.Y - a.Y}, c) * cross({b.X - a.X, b.Y - a.Y}, d) < 0) && (cross({d.X - c.X, d.Y - c.Y}, a) * cross({d.X - c.X, d.Y - c.Y}, b) < 0);
}

int main() {
  srand(42);
  while (scanf("%d", &N) == 1 && N > 0) {
    segs.clear();
    scanf("%d%d%d%d", &x1, &y1, &x2, &y2);
    REP(i, N) {
      REP(j, 4) {
        int x,y;
        scanf("%d%d", &x, &y);
        poly[j * 2] = x, poly[j * 2 + 1] = y;
      }
      if (i > 0) {
        REP(j, 4) REP(k, j) {
          segs.push_back({{poly[j * 2], poly[j * 2 + 1]}, {poly[k * 2], poly[k * 2 + 1]}});
        }
      }
    }
    int cnt = 0;
        bool ok = true;
    REP(steps, 15000) {
      double k = (double)rand() / RAND_MAX;
      pii point = {k * x1 + (1 - k) * x2, k * y1 + (1 - k) * y2};
      REP(i, (int)segs.size()) {
        ok = true;
        REP(j, 4) {
          if (intersect(point, {poly[j * 2], poly[j * 2 + 1]}, segs[i].X, segs[i].Y)) { ok = false; break; }
        }
        if (!ok) break;
      }
      if (ok) ++cnt;
    }
    printf("%lf\n", (double)cnt / 10000);
  }
  return 0;
}
